import java.util.*;
import java.io.*;
import java.net.*;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;

public class ViewCA extends Applet implements AdjustmentListener{
//public class test extends JApplet{
    int cellSizeX,cellSizeY;
    int startX,startY;
    int nstep;
    int currentStep;
    int[][][] cell;
    Scrollbar slider;
    PanelCell cellPanel;
    Panel sliderPanel;

    Graphics bg;
    Image buf;
    Dimension d;	      
    
    public void init(){
	readData();
	
	slider = new Scrollbar(Scrollbar.HORIZONTAL,0,1,0,nstep-1);
	cellPanel = new PanelCell();
	sliderPanel = new Panel(new BorderLayout());
	
	startX = cellSizeX/2;
	startY = cellSizeY/2;

        setSize(cellSizeX*2,cellSizeY*2+30);

	BorderLayout layout = new BorderLayout();
	setLayout(layout);

	add(sliderPanel,BorderLayout.SOUTH);
	add(cellPanel,BorderLayout.NORTH);
	
	slider.addAdjustmentListener(this);
	sliderPanel.add(slider,BorderLayout.CENTER);
	
	buf=createImage(cellSizeX*2,cellSizeY*2);

	bg=buf.getGraphics();
    }
    
    void readData(){
	String fileName;
	
	fileName = getParameter("FileName");
        if(fileName == null){
            fileName = "CA_result.dat";
        }
        
        BufferedReader bufReader = null;
        try{
            String line;
            URL url;
            url = new URL(getCodeBase() + fileName);
            InputStream in = 
		new DataInputStream(url.openConnection().getInputStream());
            bufReader = new BufferedReader(new InputStreamReader(in));
            
            line = bufReader.readLine();

	    StringTokenizer st = new StringTokenizer(line, " ");
	    
	    nstep = Integer.parseInt(st.nextToken());
	    cellSizeX = Integer.parseInt(st.nextToken());
	    cellSizeY = Integer.parseInt(st.nextToken());
	    
	    int istep,ix,iy;
	    int[] tmp;
	    int i,ntop;
	    tmp = new int[nstep*cellSizeX*cellSizeY];
	    cell = new int[nstep][cellSizeX][cellSizeY];

	    ntop = 0;

	    while((line = bufReader.readLine())!= null){
		st = new StringTokenizer(line, " ");
		while(st.hasMoreTokens()){
		    tmp[ntop++] = Integer.parseInt(st.nextToken());
		}
	    }

	    ntop = 0;
	    System.out.println(nstep);
	    for(istep=0;istep<nstep;istep++){
		for(ix=0;ix<cellSizeX;ix++){
		    for(iy=0;iy<cellSizeY;iy++){
			cell[istep][ix][iy] = tmp[ntop++];
		    }
		}
	    }
	    
        }catch(Exception e){
        }finally{
            if(bufReader != null){
                try{
                    bufReader.close();
                }catch(IOException e){
                }
            }
        }
    }

    void setCurrentStep(int currentStep){
	this.currentStep = currentStep;
    }

    class PanelCell extends Panel {
	public void paintComponents(Graphics g) {
	    super.paintComponents(g);
	    g.setColor(Color.black);
	    g.fillRect(0,0,cellSizeX*2,cellSizeY*2);
	    for(int j=0;j<cellSizeX;j++){
		for(int k=0;k<cellSizeY;k++){
		    if(cell[currentStep][j][k]==1){
			g.setColor(Color.black);
			g.fillRect(startX+j,startY+k,1,1);
		    }else{
			g.setColor(Color.white);
			g.fillRect(startX+j,startY+k,1,1);
		    }
		}
	    }
	
	    g.setColor(Color.black);
	    g.drawRect(startX,startY,cellSizeX,cellSizeY);
	}
    }
    
    public void adjustmentValueChanged(AdjustmentEvent ae)
    {
	setCurrentStep(slider.getValue());
	repaint();

    }
    
    public void draw(){
	cellPanel.paintComponents(bg);
    }
    
    public void update(Graphics g){
	paint(g);
    }
    
    public void paint(Graphics g){
	draw();
	g.drawImage(buf,0,0,this);
	sliderPanel.repaint();
    }    
}




